/**********************************************
* J[tj^pNTSCrfIo̓Cu
* t@C: NTSC_Lib2.c
* NbN80MHz 40MIPSOƂ 
**********************************************/
#include "p33FJ64GP802.h"
#include "NTSC.h"
#include "ASCII16dot.h"				// ASCII font 16x16 dot

/** Xe[gXVp萔` **/
unsigned char VS[4] = {SV_SYNC, SV_POSTEQ, SV_LINE, SV_PREEQ};
unsigned char VC[4] = {V_SYNC, V_POSTEQ, V_RES, V_PREEQ};

/** ϐ` **/
volatile unsigned int *VPtr, *MPtr;	// VRAM֘A|C^
volatile unsigned int  VCount, VState, DotCount;
/** XN[萔 ***/
volatile unsigned int ScrShift, ScrPitch, ScrCounter;

/** VRAM rfI̒`  **/
unsigned int __attribute__((far)) VMem[VRAM/2];

/**********************************************************
*  rfIhCo֐Q
**********************************************************/
/*********************************************
* rfI֘A֐
* ֘AW[
*  Timer2, Timer3, OC1, OC2, OC3, SPI1
*********************************************/
void VideoInit(void){

	/* I[vhCݒ */
	ODCB = 0x0380;					// RP7,8,9 OpenDrain
	/* OC1̏ݒACLKó@Fcy= 40MHz  */
	OC1CON = 0x000E;					// Timer3, PWM[
	OC1RS = 3;						// Duty 50%
	RPOR3bits.RP7R = 18;				// OC1o͂RP7sɊt
	/* ^C}3̏ݒ  */
	PR3 = 0x0005;						// 6.67MHzɐݒ
	T3CON = 0x8000;					// ^C}X^[g
	/* ^C}2̏ݒ,63.6usec(15.73kHz)A1:1  */
	T2CON = 0x0000;					// ^C}2~AFcyw
	PR2 = H_NTSC - 1; 				// 63.5usecɐݒ
	IPC1bits.T2IP = 4;				// ^C}2荞݃x4
	IFS0bits.T2IF = 0;
	IEC0bits.T2IE = 1;				// 荞ݗL
	/* SPI1̏ݒ */
	SPI1CON1 = 0x042B;				// }X^[h,16rbg,SSȂ,1:6
	SPI1CON2 = 0;						// t[Ȃ
	IPC2bits.SPI1IP = 4;				// 荞݃x4
	IFS0bits.SPI1IF = 0;
	IEC0bits.SPI1IE = 1;				// 荞ݗL
	SPI1STAT = 0x8000;				// SPI|[gL
	/* OC2̊荞ݗL  */
	IPC1bits.OC2IP = 4;				// 荞݃x4
	IFS0bits.OC2IF = 0;
	IEC0bits.OC2IE = 1;				// 荞ݗL
	/* OC3̊荞ݗL */
	IPC6bits.OC3IP = 4;				// 荞݃x4
	IFS1bits.OC3IF = 0;
	IEC1bits.OC3IE = 1;				// 荞ݗL
	/* ϐݒ */
	VState = 0;						// Xe[g}V
	VCount = V_PREEQ;					// CJE^lZbg
	ScrCounter = 0;					// XN[
	ScrShift = 0;
	ScrPitch = 0;
	AllClear(0);						// Sʏ
	VPtr = VMem;						// rfI|C^
	T2CONbits.TON = 1;				// Ń^C}2X^[g
}
/******************************************
*  ^C}2 荞ݏ֐
*@63.5s
*******************************************/
void __attribute__((interrupt,__no_auto_psv__, __shadow__)) _T2Interrupt(void)
{
	HSYNC = 0;						// Lowo͊Jn
	VCount--;						// CJE^XV
	OC2R = H_SYNC;					// pX4.1usecɃZbg
	OC2CON = 0x0001;					// ^C}2IVbg@L->H
	/** Xe[g(VState)ɂ蕪 **/

	switch(VState)
	{
		case SV_SYNC:				// pXJn
			VSYNC = 0;				// pXLowo͊Jn
			break;
		case SV_POSTEQ:				// ʏ㕔uLOI
			VSYNC = 1;				// pXHighɖ߂
			if(VCount == 0)			// ŌォH
				VPtr = VMem;			// ŏɖ߂
			break;
		case SV_LINE:				// f\Ԓ
			OC3R = H_BACK;			// fJn܂ł̒x 12.3usecɃZbg
			OC3CON = 0x0001;			// ^C}2IVbg@L->H
			break;
		case SV_PREEQ:				// ʉuNI
			break;
		default: break;

	}
	/*** CJE^,Xe[gXV  ***/
	if(VCount == 0){					// Xe[gCJEgIH
		VCount = VC[VState];			// CJE^XV
		VState = VS[VState];			// Xe[gXVЂƂi܂
	}
	/*** XN[̐  ****/
	if(ScrPitch != 0){				// XN[w肠肩H
		ScrCounter++;					// XN[pJE^XV
		if(ScrCounter > ScrPitch){		// XN[^C~OH
			ScrShift++;				// XN[XV
			ScrCounter = 0;			// ^C~OZbg
			if(ScrShift > H_RES/16-1)	// XN[Vtg1ʏIH
				ScrShift = 0;			// ŏɖ߂
		}
	}		
	IFS0bits.T2IF = 0;				// ^C}2荞݃tONA
}
/******************************************
*  OC2荞ݏ֐
*   pX
******************************************/
void __attribute__((interrupt,no_auto_psv, shadow)) _OC2Interrupt(void)
{
	HSYNC = 1;						// pXIt 4.1us
	IFS0bits.OC2IF = 0;				// 荞݃tONA
}
/*****************************************
*  OC3荞ݏ֐
*   fo͊JngK
*   XN[ł炷(ScrShift)
*****************************************/
void __attribute__((interrupt,no_auto_psv, shadow)) _OC3Interrupt(void)
{
	/**	rfIMo **/
	SPI1BUF = *((VPtr++)+ScrShift);			// ŏSPI[ho͂𒼂o
	while(SPI1STATbits.SPITBF);			// fB[҂
	SPI1BUF = *((VPtr++)+ScrShift);			// 2ԖڂSPIf[^AĒo
	DotCount = 2;							// hbg[hJE^lZbg
	IFS1bits.OC3IF = 0;					// 荞݃tONA
}
/******************************************
*  SPI1荞ݏ
*   S̃XN[@\t
*   fó@H_REShbg
*******************************************/
void __attribute__((interrupt, no_auto_psv, shadow)) _SPI1Interrupt(void)
{
	unsigned int dumy;

	if(DotCount < H_RES/16-1){					// ŏ2W炵񐔂JԂ
		SPI1BUF = *(VPtr + ScrShift);			// XN[ďo͎s
		VPtr++;								// ̃f[^w
		if((VPtr+ScrShift) > &VMem[VRAM/2])		// ʃf[^ŌɂȂŏɖ߂
			VPtr = VMem;						// XN[łĂꍇ
	}
	else{
		if(DotCount == H_RES/16-1)				// PC̍ŌォH
			/** Ō0_~[o͂SPȈo͂LowɈێ ***/
			SPI1BUF = *((VPtr++)+ScrShift) & 0xFFFE;
	}
	dumy = SPI1BUF;							// _~[[h
	DotCount++;								// hbgJE^(16hbgP)XV
	IFS0bits.SPI1IF = 0;						// 荞݃tONA
}
/********************************************
*  \Fݒ萧֐
********************************************/
void SetColor(unsigned char color){
	color &= 0x07;						// only lower 3bit
	switch(color){
		case 0:				// Black
			VBLUE = 0;			// Blue
			VGREEN = 0;			// Green
			VRED = 0;			// Red
			break;
		case 1:				// Blue
			VBLUE = 7;
			VGREEN = 0;
			VRED = 0;				
			break;
		case 2:				// Green
			VBLUE = 0;
			VGREEN = 7;
			VRED = 0;				
			break;
		case 3:				// Cyan
			VBLUE = 7;
			VGREEN = 7;
			VRED = 0;				
			break;
		case 4:				// Red
			VBLUE = 0;
			VGREEN = 0;
			VRED = 7;				
			break;
		case 5:				// Magenta
			VBLUE = 7;
			VGREEN = 0;
			VRED = 7;				
			break;
		case 6:				// Yellow
			VBLUE = 0;
			VGREEN = 7;
			VRED = 7;				
			break;
		case 7:				// White
			VBLUE = 7;
			VGREEN = 7;
			VRED = 7;				
			break;
		default : break;
	}
}
/************************************************************
* `x֐Q
************************************************************/
/*****************************************
* XN[
*****************************************/
void Scrole(unsigned int pitch){
	ScrPitch = pitch;
}
/******************************************
*  SʃNA
*@16rbgŒp^[őŜݒ肷
******************************************/
void AllClear(int patn){
	int i;

	MPtr = VMem;						// VRAM|C^Zbg	
	for(i=0; i<VRAM/2; i++)
		*MPtr++ = patn;				// Œp^[ݒ
}


/*****************************
* iXAYj_`֐
******************************/
void Plot(unsigned int x, unsigned int y)
{
	/* W͈͓łΓ_` */
	if((x < H_RES) && (y < V_RES))
		/** [hPʂŃrbgʒuvZ@ɂPZbg **/
		VMem[y * (H_RES/16) + x / 16] |= (0x8000 >> (x & 0x000F));
}

/****************************
*  `֐	
****************************/
#define	abs(a)	(((a)>0) ? (a) : -(a))
void Line(int x0, int y0, int x1, int y1)
{
	int steep, t;
	int	deltax, deltay, error;
	int x, y;
	int ystep;

	/** ̑傫ق߂ **/
	steep = (abs(y1 - y0) > abs(x1 - x0));
	/* A̓ւ */
	if(steep){
		t = x0; x0 = y0; y0 = t;
		t = x1; x1 = y1; y1 = t;
	}
	if(x0 > x1) {
		t = x0; x0 = x1; x1 = t;
		t = y0; y0 = y1; y1 = t;
	}
	deltax = x1 - x0;				// XvZ	
	deltay = abs(y1 - y0);
	error = 0;
	y = y0;
	/* XŃXebv̐؂ւ */
	if(y0 < y1) ystep = 1; else ystep = -1;
	/* _ŕ` */
	for(x=x0; x<=x1; x++) {
		if(steep) Plot(y,x); else Plot(x,y);
		error += deltay;
		if((error << 1) >= deltax) {
			y += ystep;
			error -= deltax;
		}
	}
}
/*****************************************
*  ~`֐@S(x0,y0)@ar
******************************************/
void Circle(int x0, int y0, int r)
{
	short x = r;
	short y = 0;
	short F = -2 + r + 3;

	while(x >= y){
		Plot(x0+x, y0+y);
		Plot(x0-x, y0+y);	
		Plot(x0+x, y0-y);
		Plot(x0-x, y0-y);
		Plot(x0+y, y0+x);
		Plot(x0-y, y0+x);	
		Plot(x0+y, y0-x);
		Plot(x0-y, y0-x);
		if(F >= 0){
			x--;
			F -= 4 * x;
		}
		y++;
		F += 4 * y + 2;
	}
}

/*******************************************
*  `֐@16x16hbgp
********************************************/
void PutChar(int x, int y, unsigned char asci)
{
	int i;

	if((x < 20) && (y < 13)){				// 2013sH	
		x = x * 16;						// 16dot pitch
		y = y * 17;						// 17dot picth
		for(i=0; i<32; i+=2){
			VMem[(y)*(H_RES/16)+x/16] = ASCII16dot[asci][i]*256 + ASCII16dot[asci][i+1];
			y++;
		}
	}
}
/******************************
*   `֐(16x16 dot)
*   2013sŎw
******************************/
void PutStr(char colum, char line, const char *s)
{
    	while (*s){
		PutChar(colum++, line, *s++);
		if(colum >= 20){				// 1s̍ŌɂȂH
			line++;					// ̍s
			colum = 0;				// s擪
			if(line >= 13)			// Ō̍s𒴂H
				line = 0;			// 擪s
		}
	}
}
	
/**********************************
*  [vx֐@usecP
**********************************/
void delay_us(unsigned short usec){
	unsigned short i, Max;
	
	Max = usec * Fosc/14;
	for(i=0; i<Max; i++)
	{	}
}
/**********************************
*  [vx֐@msecP
*  ő6b܂
**********************************/		 
void delay_ms(unsigned short msec){
	unsigned short i;
	
	for(i=0; i<msec*10; i++)
		delay_us(100);
}


